SystemOrganization addCategory: #'Magritte-Core-Descriptions'!
SystemOrganization addCategory: #'Magritte-Core-Accessors'!
SystemOrganization addCategory: #'Magritte-Core-Comparators'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utilities'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAError
	instanceVariableNames: 'resumable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 13:51'!
description: aDescription message: aString
	^self description: aDescription message: aString resumable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 13:51'!
description: aDescription message: aString resumable: aBoolean
	^self new
		tag: aDescription;
		resumable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'testing' stamp: 'lr 3/21/2005 13:50'!
isResumable
	^self resumable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:49'!
resumable
	^resumable! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:50'!
resumable: aBoolean
	resumable := aBoolean! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

Object subclass: #MAAccessor
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MAAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^true! !

!MAAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 16:36'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MAAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:23'!
on: aDescription
	^self new
		setDescription: aDescription;
		yourself.! !

!MAAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:16'!
description
	^description! !

!MAAccessor methodsFor: 'copying' stamp: 'lr 3/30/2005 14:16'!
postCopy
	super postCopy.
	self setDescription: nil.! !

!MAAccessor methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:12'!
setDescription: aDescription
	description := aDescription! !

MAAccessor subclass: #MAModelAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

MAModelAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:26'!
read: aReadBlock write: aWriteBlock
	^self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 10:01'!
read: aModel
	^self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock
	^readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock
	^writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAModelAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:51'!
cascade: anArray
	^anArray allButLast reverse
		inject: anArray last
		into: [ :next :accessor | 
			self new
				next: next; 
				accessor: accessor;
				yourself ].! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:50'!
selectors: anArray
	^self cascade: (anArray collect: [ :each | 
		MASelectorAccessor selector: each ]).! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
accessor
	^accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
next
	^next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 3/30/2005 22:10'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/30/2005 10:54'!
read: aModel
	^self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'initialize' stamp: 'lr 3/27/2005 09:53'!
setDescription: aDescription
	super setDescription: aDescription.
	self accessor setDescription: aDescription.
	self next setDescription: aDescription.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAModelAccessor subclass: #MAComposedAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MAComposedAccessor class methodsFor: 'testing' stamp: 'lr 4/5/2005 13:10'!
isAbstract
	^false! !

!MAComposedAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
read: aModel
	^aModel.! !

!MAComposedAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 3/31/2005 09:52'!
isNull
	^false! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 3/30/2005 16:50'!
isShortcut
	^false! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
read: aModel
	"Read from aModel using the description of the receiver."
	
	self subclassResponsibility.! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
write: anObject to: aModel
	"Write to aModel using the description of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAModelAccessor subclass: #MANullAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 3/31/2005 09:52'!
isNull
	^true! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
read: aModel
	self error: 'Not supposed to read from ' , aModel asString , '.'.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAModelAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:39'!
read: aReadSelector write: aWriteSelector
	^self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:40'!
selector: aSelector
	^self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:03'!
read: aModel
	^aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector
	^readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:40'!
selector
	^self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:39'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector
	^writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAAccessor subclass: #MAModelWrapper
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

MAModelWrapper subclass: #MACachedWrapper
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MACachedWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MACachedWrapper methodsFor: 'actions' stamp: 'lr 3/30/2005 22:47'!
commit
	super commit.
	self push: self value.! !

!MACachedWrapper methodsFor: 'actions' stamp: 'lr 3/30/2005 22:47'!
reset
	super reset.
	self value: self pull.! !

!MACachedWrapper methodsFor: 'initialization' stamp: 'lr 3/31/2005 09:53'!
setModel: aModel
	super setModel: aModel.
	self reset.
	
! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:21'!
value
	^value! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:23'!
value: anObject
	value := anObject! !

!MAModelWrapper class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:51'!
on: aDescription model: aModel
	^(self on: aDescription)
		setModel: aModel;
		yourself.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:08'!
accessor
	^self description accessor.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 3/30/2005 23:04'!
commit
	self description isReadonly
		ifTrue: [ self errorReadonly ]
		ifFalse: [ self validate ].! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 3/30/2005 22:43'!
errorReadonly
	MAReadonlyError 
		description: self description
		message: self description asLabel , ' is readonly.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 3/30/2005 22:43'!
errorRequired
	MARequiredError 
		description: self description  
		message: self description asLabel , ' is required.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 3/30/2005 22:43'!
errorValidation
	MAValidationError 
		description: self description  
		message: self description asLabel , ' is invalid.'.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:16'!
model
	^model! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 4/4/2005 18:10'!
next
	^self class! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/5/2005 11:57'!
pull
	"Primitive to read from the model. Do not call directly use #value instead."

	^(self model readUsing: self description)
		ifNil: [ self description default ].! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 3/30/2005 16:35'!
push: anObject
	"Primitive to write to the model. Do not call directly use #value: instead."

	self model write: anObject using: self description.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 3/30/2005 15:03'!
reset! !

!MAModelWrapper methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:52'!
setModel: aModel
	model := aModel.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 3/30/2005 22:45'!
validate
	"Check if the receiver can be written to the model. In case of problems an exception is raised."

	(self description isRequired and: [ self value isNil ])
		ifTrue: [ self errorRequired ].
	(self value isNil or: [ self description includes: self value ])
		ifFalse: [ self errorValidation ].! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 15:20'!
value
	self subclassResponsability.! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 15:20'!
value: anObject
	self subclassResponsability! !

MAModelWrapper subclass: #MAStraitWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessors'!

!MAStraitWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MAStraitWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 16:34'!
value
	^self pull.! !

!MAStraitWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 16:34'!
value: anObject
	^self push: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/24/2005 15:12'!
buildFor: anObject
	| description |
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				(description isKindOf: MADescription)
					ifTrue: [ container := container , description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 10:56'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:56'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MAComparator
	instanceVariableNames: ''
	classVariableNames: 'BeginsWith MagnitudeSorter BooleanSorter EqualTo GreaterThanOrEqualTo NotEqualTo GreaterThan LessThanOrEqualTo StringSorter LessThan Match EndsWith NullSorter'
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
beginsWith
	^BeginsWith! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
booleanSorter
	^BooleanSorter! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
endsWith
	^EndsWith! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:12'!
equalTo 
	^EqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:45'!
equalityComparators
	^Array with: self equalTo with: self notEqualTo.! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
greaterThan	
	^GreaterThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:18'!
greaterThanOrEqualTo
	^GreaterThanOrEqualTo! !

!MAComparator class methodsFor: 'class initialization' stamp: 'lr 3/31/2005 07:31'!
initialize

	" equality comparators "
	EqualTo := MAGenericComparator label: 'is' selector: #=.
	NotEqualTo := MAGenericComparator label: 'is not' selector: #~=.
	
	" magnitude comparators "
	LessThan := MAGenericComparator label: 'is less than' selector: #<.
	LessThanOrEqualTo := MAGenericComparator label: 'is less than or equal to' selector: #<=.
	GreaterThan := MAGenericComparator label: 'is greater than' selector: #>.
	GreaterThanOrEqualTo := MAGenericComparator label: 'is greater than or equal to' selector: #>=.
	
	" string comparators "
	BeginsWith := MAGenericComparator label: 'starts with' selector: #beginsWith:.
	EndsWith := MAGenericComparator label: 'ends with' selector: #endsWith:.
	Match := MAMatchComparator new.
	
	" sorters "
	NullSorter := MASortingComparator block: [ :a :b | true ].
	MagnitudeSorter := MASortingComparator block: [ :a :b | a <= b ].
	StringSorter := MASortingComparator block: [ :a :b | (a compare: b) <= 2 ].
	BooleanSorter := MASortingComparator block: [ :a :b | a not or: [ b ] ].! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThan
	^LessThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThanOrEqualTo
	^LessThanOrEqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:46'!
magnitudeComparators
	^Array with: self lessThan with: self lessThanOrEqualTo with: self greaterThan with: self greaterThanOrEqualTo.! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
magnitudeSorter
	^MagnitudeSorter! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:53'!
match
	^Match! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:13'!
notEqualTo
	^NotEqualTo! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
nullSorter
	^NullSorter! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:53'!
stringComparators
	^Array with: self beginsWith with: self endsWith with: self match.! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
stringSorter
	^StringSorter! !

!MAComparator methodsFor: 'private' stamp: 'lr 3/17/2005 15:30'!
compare: aLeftObject to: aRightObject
	self subclassResponsibility.! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 3/17/2005 15:38'!
compare: aLeftObject with: aRightObject
	^[ self compare: aLeftObject to: aRightObject ]
		ifError: [ false ].! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 4/2/2005 21:20'!
compare: aLeftObject with: aRightObject description: aDescription
	^(aDescription comparators includes: self) and: [
		self
			compare: (aDescription accessor read: aRightObject)
			with: (aDescription parseString: aLeftObject) ].! !

!MAComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector
	^nil! !

MAComparator subclass: #MAGenericComparator
	instanceVariableNames: 'label selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAGenericComparator class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 21:43'!
label: aString selector: aSelector
	^self new
		setLabel: aString;
		setSelector: aSelector;
		yourself.! !

!MAGenericComparator methodsFor: 'converting' stamp: 'lr 3/24/2005 00:54'!
asLabel
	^label! !

!MAGenericComparator methodsFor: 'private' stamp: 'lr 3/19/2005 21:42'!
compare: aLeftObject to: aRightObject
	^aLeftObject perform: selector with: aRightObject.! !

!MAGenericComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector	
	^selector! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:54'!
setLabel: aString
	label := aString! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/19/2005 21:41'!
setSelector: aSymbol
	selector := aSymbol! !

MAComparator subclass: #MAMatchComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAMatchComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 22:27'!
asLabel
	^ 'match'! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/20/2005 01:13'!
compare: aLeftObject to: aRightObject
	^(self patternFor: aRightObject) match: aLeftObject.! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/21/2005 20:56'!
includesJoker: aString
	^aString includesAnyOf: '*#'.! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/19/2005 22:31'!
patternFor: aString
	^(self includesJoker: aString)
		ifTrue: [ aString ]
		ifFalse: [ '*' , aString , '*' ].! !

!MAMatchComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector
	^ #match:! !

MAComparator subclass: #MASortingComparator
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MASortingComparator class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:55'!
block: aBlock
	^self new
		setBlock: aBlock;
		yourself.! !

!MASortingComparator methodsFor: 'converting' stamp: 'lr 3/24/2005 00:55'!
asLabel
	^ 'sorts before'! !

!MASortingComparator methodsFor: 'private' stamp: 'lr 3/24/2005 09:45'!
compare: aLeftObject to: aRightObject
	^aLeftObject isNil 
		or: [ aRightObject notNil
		and: [ block value: aLeftObject value: aRightObject ] ].! !

!MASortingComparator methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:50'!
setBlock: aBlock
	block := aBlock! !

Object subclass: #MADescription
	instanceVariableNames: 'properties accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/5/2005 13:09'!
defaultAccessorClass
	^MAComposedAccessor! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/24/2005 00:15'!
defaultCollection
	^OrderedCollection new.! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 09:57'!
new
	^super new
		setChildren: self defaultCollection;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:07'!
with: aDescription
	^self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:08'!
withAll: aCollection
	^self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/24/2005 00:09'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
collect: aBlock
	^self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:08'!
copyFrom: aStartIndex to: anEndIndex
	^self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 17:31'!
detect: aBlock 
	^self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 10:42'!
detect: aBlock ifNone: anExceptionBlock 
	^self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^self notEmpty.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/21/2005 20:07'!
includes: aDescription
	^self children includes: aDescription.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
inject: anObject into: aBlock 
	^self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:32'!
isEmpty
	^self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 3/24/2005 00:24'!
moveDown: aDescription
	| index |
	index := self children indexOf: aDescription ifAbsent: [ ^self ].
	self children swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAContainer methodsFor: 'moving' stamp: 'lr 3/21/2005 19:24'!
moveUp: aDescription
	| index |
	index := self children indexOf: aDescription ifAbsent: [ ^self ].
	self children swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:39'!
notEmpty
	^self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:36'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
reject: aBlock
	^self copy 
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 00:09'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 10:08'!
removeAll
	children := self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
select: aBlock
	^self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:13'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/24/2005 00:11'!
size
	^self children size.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 15:31'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/24/2005 00:25'!
defaultCollection
	^SortedCollection sortBlock: [ :a :b | a priority <= b priority ].! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 3/24/2005 00:25'!
moveDown: aDescription! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 3/24/2005 00:25'!
moveUp: aDescription! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultCaption
	^nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultEmpty
	^'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 3/23/2005 23:51'!
defaultPageSize
	^10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowBatch
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowFooter
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowHeader
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultSummary
	^nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionCaption
	^MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionEmpty
	^MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:09'!
descriptionPageSize
	^MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowBatch
	^MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowFooter
	^MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowHeader
	^MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:10'!
descriptionSummary
	^MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption
	^self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty
	^self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:51'!
pageSize
	^self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:50'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch
	^self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showFooter
	^self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader
	^self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary
	^self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:42'!
asLabel
	^super asLabel allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/30/2005 15:31'!
defaultAccessorClass
	^MANullAccessor! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 07:21'!
defaultComment
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/19/2005 12:30'!
defaultPersistent
	^true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionComment
	^MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionLabel
	^MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPersistent
	^MABooleanDescription selector: #persistent label: 'Persistent' priority: 330 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPriority
	^MANumberDescription selector: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionReadonly
	^MABooleanDescription selector: #readonly label: 'Readonly' priority: 300 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionRequired
	^MABooleanDescription selector: #required label: 'Required' priority: 320 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionVisible
	^MABooleanDescription selector: #visible label: 'Visible' priority: 310 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/28/2005 19:03'!
isAbstract
	^true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 19:03'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'operators' stamp: 'lr 3/24/2005 12:31'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:33'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessorClass new ].
	^accessor.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/31/2005 09:44'!
accessor: anAccessor	
	accessor := anAccessor.
	accessor isNil
		ifFalse: [ accessor setDescription: self ].! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/24/2005 00:04'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/27/2005 10:52'!
asLabel
	^self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
comment	
	^self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/23/2005 07:28'!
hasComment
	^(self propertyAt: #comment ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/27/2005 12:01'!
hasLabel
	^(self propertyAt: #label ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/14/2005 18:11'!
isPersistent
	^self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'operators' stamp: 'lr 4/4/2005 21:29'!
key
	^[ self accessor selector ]
		ifError: [ :err | err return: nil ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
label	
	^self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
persistent	
	^self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/14/2005 18:11'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 3/31/2005 09:41'!
postCopy
	super postCopy.
	self properties: self properties copy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 3/27/2005 11:01'!
printOn: aStream
	super printOn: aStream.
"	aStream nextPutAll: ' accessor: '; print: self accessor."
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
priority
	^self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/17/2005 15:17'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^properties.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/31/2005 09:41'!
properties: aDictionary
	properties := aDictionary! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsent: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey ifAbsentPut: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey put: aValue
	^self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
readonly	
	^self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
required	
	^self propertyAt: #required 	ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
visible	
	^self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MABinaryDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Upload'! !

!MABinaryDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 21:39'!
descriptionDefault
	^nil! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 3/30/2005 07:30'!
kind
	^ByteArray! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 21:41'!
parseString: aString
	^self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Check-Box'! !

!MABooleanDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Boolean! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:10'!
parseString: aString
	^self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^false ].
		aString ].! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor
	^self accessor: anAccessor label: self defaultLabel.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor label: aString
	^self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:21'!
accessor: anAccessor label: aString priority: aNumber
	^self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:20'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MAElementDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:48'!
defaultDefault
	^nil! !

!MAElementDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionDefault
	^self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 200 default: self defaultDefault ].! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector
	^self accessor: (MASelectorAccessor selector: aSelector).! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector label: aString
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber default: anObject
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^MAContainer with: self.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:00'!
collectionToString: aCollection
	^String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/17/2005 16:16'!
comparators
	^MAComparator equalityComparators.! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default
	^default! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default: anObject
	default := anObject! !

!MAElementDescription methodsFor: 'testing' stamp: 'lr 3/23/2005 14:19'!
includes: anObject
	"Return true or false wether anObject is a proper value of the receiver."

	^anObject isKindOf: self kind.! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 14:16'!
kind
	^self subclassResponsibility.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/14/2005 16:12'!
migrate: anObject from: aDescription
	^self parseString: (aDescription toString: anObject).! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/14/2005 16:15'!
parseString: aString
	^self parseString: aString protected: [ aString ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/3/2005 12:26'!
parseString: aString protected: aBlock
	^aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'copying' stamp: 'lr 3/28/2005 11:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self default: self default copy.! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/24/2005 00:40'!
sorter
	^MAComparator lessThanOrEqualTo.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:01'!
stringToCollection: aString default: aCollection
	^aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			((aString findTokens: Character cr)
				collect: [ :each | each withBlanksCondensed ])
					select: [ :each | each notEmpty ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/21/2005 19:15'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asLabel ].! !

!MAElementDescription methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:13'!
validate: anObject
	"Check if anObject can be written to the model described by the receiver. In case of problems an exception is raised."

	(self isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self includes: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAElementDescription methodsFor: 'testing' stamp: 'lr 3/14/2005 11:09'!
validates: anObject
	[ self validate: anObject ] 
		on: Error 
		do: [ :err | ^false ].
	^true.! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Duration! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 16:17'!
comparators
	^super comparators , MAComparator magnitudeComparators.! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 3/23/2005 14:19'!
parseString: aString
	^self parseString: aString protected: [ self kind fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Number! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asNumber ].! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^TimeStamp! !

MAElementDescription subclass: #MAOptionsDescription
	instanceVariableNames: 'options none'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAOptionsDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Option-Box'! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/29/2005 20:19'!
defaultNone
	^String new.! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:38'!
defaultOptions
	^OrderedCollection new.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/14/2005 12:16'!
descriptionDefault
	^nil! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:19'!
descriptionNone
	^MAStringDescription selector: #none label: 'None Label' priority: 150.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:19'!
descriptionOptions
	^MATextDescription selector: #optionsTextual label: 'Options' priority: 160.! !

!MAOptionsDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAOptionsDescription methodsFor: 'testing' stamp: 'lr 3/11/2005 22:38'!
includes: anObject
	^self options includes: anObject.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Object! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/29/2005 20:19'!
none
	none isNil
		ifTrue: [ self none: self class defaultNone ].
	^none.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/29/2005 20:20'!
none: aString
	none := aString! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual
	^self collectionToString: self options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MAOptionsDescription methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 3/14/2005 14:09'!
isObfuscated: aString
	^aString notNil and: [ aString allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'converting' stamp: 'lr 3/11/2005 21:46'!
obfuscated: aString
	^aString isEmptyOrNil
		ifFalse: [ Array new: aString size withAll: $* ].! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Text Field'! !

!MAStringDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:47'!
defaultDefault
	^String new.! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 15:12'!
comparators
	^super comparators , MAComparator stringComparators.! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Symbol Field'! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Symbol! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asSymbol ].! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATableDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Table'! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/16/2005 20:33'!
defaultCellDescription
	^self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/17/2005 15:12'!
defaultCellDescriptionClasses
	^Array 
		with: MAStringDescription
		with: MATextDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultColumnLabels
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultDefault
	^Array new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultRowLables
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:23'!
descriptionCellDescription
	^(MAOptionsDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionColumnLabels
	^MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:06'!
descriptionDefault
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRequired
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionRowLabels
	^MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/29/2005 20:59'!
cellCount
	^self columnCount * self rowCount.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:26'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:27'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:38'!
columnCount
	^self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual
	^self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual: aString
	^self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableDescription methodsFor: 'testing' stamp: 'lr 3/29/2005 21:17'!
includes: anObject
	^(super includes: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
indexAt: aRowIndex at: aColIndex
	^aRowIndex - 1 * self columnCount + aColIndex.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/23/2005 14:17'!
kind
	^SequenceableCollection! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 3/16/2005 20:27'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 09:06'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 08:50'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:56'!
rowLabelsTextual
	^self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:57'!
rowLabelsTextual: aString
	^self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
rowOfIndex: anInteger
	^anInteger - 1 // self columnCount + 1.! !

Object subclass: #MAObjectStreaming
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAObjectStreaming subclass: #MAObjectReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAObjectStreaming class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 12:33'!
on: aStream
	^self new
		setStream: aStream;
		yourself.! !

!MAObjectStreaming methodsFor: 'initialization' stamp: 'lr 3/19/2005 13:01'!
setStream: aStream
	stream := aStream! !

!MAObjectStreaming methodsFor: 'accessing' stamp: 'lr 3/19/2005 12:59'!
stream
	^stream! !

MAObjectStreaming subclass: #MAObjectWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAObjectWriter methodsFor: 'as yet unclassified' stamp: 'lr 3/19/2005 13:29'!
nextPut: anObject
	" not working, need something more sofisticated than this "

	self stream 
		nextPutAll: 't1 := '; 
		nextPutAll: anObject class name; 
		nextPutAll: ' basicNew.'; 
		cr.
	anObject description do: [ :each |
		(each isPersistent and: [ each isReadonly not ]) ifTrue: [
			self stream 
				nextPutAll: 'd := t1 description at: '; 
				print: each key; 
				nextPutAll: '.'; 
				cr.
			self stream 
				nextPutAll: 'd write: (d parseString: '; 
				print: (each toString: (each read: anObject)); 
				nextPutAll: ') to: t1.';
				cr ] ].! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAScaffolder subclass: #MADescribedScaffolder
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:20'!
description
	^description! !

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:21'!
description: aDescription
	description := aDescription! !

!MADescribedScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:22'!
initialize
	super initialize.
	self description: self class defaultContainer.! !

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 22:44'!
description: aDescription
	^self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:21'!
initialize
	super initialize.
	self values: IdentityDictionary new.! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 3/28/2005 23:05'!
readUsing: aDescription
	^self values 
		at: aDescription
		ifAbsentPut: [ aDescription default ].  ! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values
	^values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 3/28/2005 23:06'!
write: anObject using: aDescription
	^self values 
		at: aDescription
		put: anObject.! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 18:30'!
asLabel
	^self name! !

!Object class methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/4/2005 18:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 3/10/2005 10:38'!
description
	^MACachedBuilder default buildFor: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 21:18'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^value asString , ' ' , each ] ].! !

TestCase subclass: #MAAccessorTest
	instanceVariableNames: 'description accessor value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:38'!
isAbstract
	^true! !

!MAAccessorTest class methodsFor: 'testing' stamp: 'lr 3/27/2005 10:05'!
shouldInheritSelectors
	^true! !

!MAAccessorTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 21:04'!
accessor
	^accessor! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:20'!
accessorInstance
	self subclassResponsability! !

!MAAccessorTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 21:04'!
description
	^description! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:20'!
descriptionInstance
	^MAStringDescription new! !

!MAAccessorTest methodsFor: 'running' stamp: 'lr 3/30/2005 21:20'!
setUp
	description := self descriptionInstance.
	description accessor: (accessor := self accessorInstance).! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:33'!
testCopy
	self assert: self accessor copy description isNil.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:41'!
testDescription
	self assert: self description accessor = self accessor.
	self assert: self accessor description = self description.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:27'!
testRead
	self subclassResponsibility.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:27'!
testWrite
	self subclassResponsibility.! !

!MAAccessorTest methodsFor: 'accessing-model' stamp: 'lr 3/30/2005 21:30'!
value
	^value! !

!MAAccessorTest methodsFor: 'accessing-model' stamp: 'lr 3/30/2005 21:30'!
value: anObject
	value := anObject! !

MAAccessorTest subclass: #MAModelAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAModelAccessorTest subclass: #MABlockAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABlockAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:39'!
isAbstract
	^false! !

!MABlockAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:41'!
accessorInstance
	^MABlockAccessor
		read: [ :model | model value ]
		write: [ :model :object | model value: object ].! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:44'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.
! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:52'!
testReadBlock
	self accessor readBlock: [ :model |
		self assert: model = self. 123 ].
	self assert: (self accessor read: self) = 123.! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:44'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:51'!
testWriteBlock
	self accessor writeBlock: [ :model :object |
		self assert: model = self.
		self assert: object = 123 ].
	self accessor write: 123 to: self.! !

MAModelAccessorTest subclass: #MACascadeAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MACascadeAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:48'!
isAbstract
	^false! !

!MACascadeAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:14'!
accessorInstance
	^MACascadeAccessor selectors: #( yourself value ).! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:03'!
testAccessor
	self assert: self accessor accessor selector = #yourself.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:12'!
testCopy
	super testCopy.
	self assert: self accessor copy next description isNil.
	self assert: self accessor copy accessor description isNil.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:03'!
testNext
	self assert: self accessor next selector = #value.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:06'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:07'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

MAModelAccessorTest subclass: #MANullAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MANullAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:48'!
isAbstract
	^false! !

!MANullAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:15'!
accessorInstance
	^MANullAccessor new! !

!MANullAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:20'!
testRead
	self 
		should: [ self accessor read: self ]
		raise: Error.! !

!MANullAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:20'!
testWrite
	self 	
		should: [ self accessor write: 123 to: self ] 
		raise: Error.
	self assert: self value isNil.! !

MAModelAccessorTest subclass: #MASelectorAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MASelectorAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:47'!
isAbstract
	^false! !

!MASelectorAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:46'!
accessorInstance
	^MASelectorAccessor selector: #value.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:56'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testReadSelector
	self accessor readSelector: #contents.
	
	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #value:.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testSelector
	self accessor selector: #contents.
	
	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #contents:.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:56'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testWriteSelector
	self accessor writeSelector: #contents:.
	
	self assert: self accessor selector = #value.
	self assert: self accessor readSelector = #value.
	self assert: self accessor writeSelector = #contents:.! !

MAAccessorTest subclass: #MAModelWrapperTest
	instanceVariableNames: 'wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAModelWrapperTest subclass: #MACachedWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MACachedWrapperTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
isAbstract
	^false! !

!MACachedWrapperTest methodsFor: 'running' stamp: 'lr 3/30/2005 22:30'!
setUp
	self value: 123.
	super setUp.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 23:10'!
testCommit
	self wrapper value: '321'; commit.
	self assert: self wrapper value = '321'.
	self assert: self value = '321'.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:30'!
testRead
	self assert: self value = 123.
	self assert: self wrapper value = 123.
	
	self value: 321.
	self assert: self value = 321.
	self assert: self wrapper value = 123.
! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:32'!
testReset
	self wrapper value: 321; reset.
	self assert: self wrapper value = 123.
	self assert: self value = 123.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:31'!
testWrite
	self wrapper value: 321.
	self assert: self value = 123.
	self assert: self wrapper value = 321.! !

!MACachedWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:24'!
wrapperInstance
	^MACachedWrapper on: self description model: self.! !

!MAModelWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:22'!
accessorInstance
	^MASelectorAccessor selector: #value.! !

!MAModelWrapperTest methodsFor: 'running' stamp: 'lr 3/30/2005 22:23'!
setUp
	super setUp.
	wrapper := self wrapperInstance.! !

!MAModelWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
testAccessor
	self assert: self wrapper accessor = self accessor.! !

!MAModelWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
testDescription
	self assert: self wrapper description = self description.! !

!MAModelWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
testModel
	self assert: self wrapper model = self.! !

!MAModelWrapperTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:22'!
wrapper
	^wrapper! !

!MAModelWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:23'!
wrapperInstance
	^self subclassResponsibility! !

MAModelWrapperTest subclass: #MAStraitWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAStraitWrapperTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
isAbstract
	^false! !

!MAStraitWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:27'!
testRead
	self value: 123.
	self assert: self wrapper value = 123.
	
	self value: 321.
	self assert: self wrapper value = 321.! !

!MAStraitWrapperTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:29'!
testWrite
	self wrapper value: 123.
	self assert: self value = 123.
	
	self wrapper value: 321.
	self assert: self value = 321.! !

!MAStraitWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:24'!
wrapperInstance
	^MAStraitWrapper on: self description model: self.! !

TestCase subclass: #MAComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
assert: aFirstObject and: aSecondObject satisfies: aSelector
	self assert: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:39'!
comparators
	^MAComparator classPool values.! !

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
deny: aFirstObject and: aSecondObject satisfies: aSelector
	self deny: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testBeginsWith
	self assert: 'ab' and: 'a' satisfies: #beginsWith.
	self assert: 'ab' and: 'ab' satisfies: #beginsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #beginsWith.
	self deny: 'ab' and: 'b' satisfies: #beginsWith.
	
	self deny: nil and: 'a' satisfies: #beginsWith.
	self deny: 'a' and: nil satisfies: #beginsWith. ! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:33'!
testBooleanSorter
	self assert: nil and: nil satisfies: #booleanSorter.
	self assert: nil and: false satisfies: #booleanSorter.
	self assert: nil and: true satisfies: #booleanSorter.
	
	self deny: false and: nil satisfies: #booleanSorter.
	self assert: false and: false satisfies: #booleanSorter.
	self assert: false and: true satisfies: #booleanSorter.
	
	self deny: true and: nil satisfies: #booleanSorter.
	self deny: true and: false satisfies: #booleanSorter.
	self assert: true and: true satisfies: #booleanSorter.! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testEndsWith
	self assert: 'ab' and: 'b' satisfies: #endsWith.
	self assert: 'ab' and: 'ab' satisfies: #endsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #endsWith.
	self deny: 'ab' and: 'a' satisfies: #endsWith.
	
	self deny: nil and: 'a' satisfies: #endsWith.
	self deny: 'a' and: nil satisfies: #endsWith. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testEqualTo
	self assert: 1 and: 1 satisfies: #equalTo.
	self deny: 1 and: 2 satisfies: #equalTo.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThan
	self deny: 1 and: 2 satisfies: #greaterThan.
	self deny: 1 and: 1 satisfies: #greaterThan.
	self assert: 2 and: 1 satisfies: #greaterThan.
	
	self deny: 1 and: nil satisfies: #greaterThan.
	self deny: nil and: 1 satisfies: #greaterThan.
! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThanOrEqualTo
	self deny: 1 and: 2 satisfies: #greaterThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #greaterThanOrEqualTo.
	self assert: 2 and: 1 satisfies: #greaterThanOrEqualTo.

	self deny: 1 and: nil satisfies: #greaterThanOrEqualTo.
	self deny: nil and: 1 satisfies: #greaterThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing' stamp: 'lr 3/17/2005 23:41'!
testLabel
	self comparators do: [ :each | 
		self deny: each asLabel isEmptyOrNil.
		self deny: each asLabel = each asString ].! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThan
	self assert: 1 and: 2 satisfies: #lessThan.
	self deny: 1 and: 1 satisfies: #lessThan.
	self deny: 2 and: 1 satisfies: #lessThan.
	
	self deny: 1 and: nil satisfies: #lessThan.
	self deny: nil and: 1 satisfies: #lessThan.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThanOrEqualTo
	self assert: 1 and: 2 satisfies: #lessThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #lessThanOrEqualTo.
	self deny: 2 and: 1 satisfies: #lessThanOrEqualTo.
	
	self deny: 1 and: nil satisfies: #lessThanOrEqualTo.
	self deny: nil and: 1 satisfies: #lessThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:50'!
testMagnitudeSorter
	self assert: nil and: nil satisfies: #magnitudeSorter.
	self assert: nil and: 0 satisfies: #magnitudeSorter.
	self assert: nil and: 1 satisfies: #magnitudeSorter.
	
	self deny: 0 and: nil satisfies: #magnitudeSorter.
	self assert: 0 and: 0 satisfies: #magnitudeSorter.
	self assert: 0 and: 1 satisfies: #magnitudeSorter.
	
	self deny: 1 and: nil satisfies: #magnitudeSorter.
	self deny: 1 and: 0 satisfies: #magnitudeSorter.
	self assert: 1 and: 1 satisfies: #magnitudeSorter.! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 22:34'!
testMatch
	self assert: 'ab' and: '*' satisfies: #match.
	self assert: 'ab' and: '##' satisfies: #match.
	self assert: 'ab' and: '#b' satisfies: #match.
	self assert: 'ab' and: '*b' satisfies: #match.
	self assert: 'ab' and: 'a*b' satisfies: #match.
	self assert: 'ab' and: 'a#' satisfies: #match.
	self assert: 'ab' and: 'a*' satisfies: #match.
	self assert: 'ab' and: 'a' satisfies: #match.
	self assert: 'ab' and: 'b' satisfies: #match.
	
	self deny: 'ab' and: 'ba' satisfies: #match.
	self deny: 'ab' and: '?a' satisfies: #match.
	self deny: 'ab' and: 'b?' satisfies: #match.
	self deny: 'ab' and: '*a' satisfies: #match.
	self deny: 'ab' and: 'b*' satisfies: #match.

	self deny: nil and: 'a' satisfies: #match.
	self deny: 'a' and: nil satisfies: #match. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testNotEqualTo
	self deny: 1 and: 1 satisfies: #notEqualTo.
	self assert: 1 and: 2 satisfies: #notEqualTo.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:51'!
testNullSorter
	self assert: nil and: nil satisfies: #nullSorter.
	self assert: nil and: 0 satisfies: #nullSorter.
	self assert: nil and: 1 satisfies: #nullSorter.
	
	self deny: 0 and: nil satisfies: #nullSorter.
	self assert: 0 and: 0 satisfies: #nullSorter.
	self assert: 0 and: 1 satisfies: #nullSorter.
	
	self deny: 1 and: nil satisfies: #nullSorter.
	self assert: 1 and: 0 satisfies: #nullSorter.
	self assert: 1 and: 1 satisfies: #nullSorter.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:54'!
testStringSorter
	self assert: nil and: nil satisfies: #stringSorter.
	self assert: nil and: 'a' satisfies: #stringSorter.
	self assert: nil and: 'z' satisfies: #stringSorter.
	
	self deny: 'a' and: nil satisfies: #stringSorter.
	self assert: 'a' and: 'a' satisfies: #stringSorter.
	self assert: 'a' and: 'z' satisfies: #stringSorter.
	
	self deny: 'z' and: nil satisfies: #stringSorter.
	self deny: 'z' and: 'a' satisfies: #stringSorter.
	self assert: 'z' and: 'z' satisfies: #stringSorter.
	
	self assert: 'a' and: 'z' satisfies: #stringSorter.
	self assert: 'A' and: 'z' satisfies: #stringSorter.
	self assert: 'a' and: 'Z' satisfies: #stringSorter.
	self assert: 'A' and: 'Z' satisfies: #stringSorter.
	
	self deny: 'z' and: 'a' satisfies: #stringSorter.
	self deny: 'Z' and: 'a' satisfies: #stringSorter.
	self deny: 'z' and: 'A' satisfies: #stringSorter.
	self deny: 'Z' and: 'A' satisfies: #stringSorter.! !

TestCase subclass: #MADescriptionTest
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MADescriptionTest subclass: #MAContainerTest
	instanceVariableNames: 'child1 child2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAContainerTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAContainerTest methodsFor: 'accessing' stamp: 'lr 3/27/2005 11:03'!
child1
	child1 isNil
		ifTrue: [ child1 := MAStringDescription selector: #child1 label: 'child1' priority: 1 ].
	^child1.! !

!MAContainerTest methodsFor: 'accessing' stamp: 'lr 3/27/2005 11:02'!
child2
	child2 isNil
		ifTrue: [ child2 := MAStringDescription selector: #child2 label: 'child2'  priority: 2 ].
	^child2.! !

!MAContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 00:06'!
descriptionClass
	^MAContainer! !

!MAContainerTest methodsFor: 'running' stamp: 'lr 3/27/2005 10:55'!
setUp
	super setUp.
	self description: self descriptionClass new.! !

!MAContainerTest methodsFor: 'testing-adding' stamp: 'lr 3/24/2005 10:05'!
testAdd
	self description add: self child1.
	self assert: (self description size = 1).
	self assert: (self description includes: self child1).
	
	self description add: self child2.
	self assert: (self description size = 2).
	self assert: (self description includes: self child1).
	self assert: (self description includes: self child2).
	
	! !

!MAContainerTest methodsFor: 'testing-adding' stamp: 'lr 3/24/2005 10:05'!
testAddAll
	self description addAll: (Array 
		with: self child1 
		with: self child2).
	
	self assert: (self description size = 2).
	self assert: (self description includes: self child1).
	self assert: (self description includes: self child2).
! !

!MAContainerTest methodsFor: 'testing' stamp: 'lr 3/24/2005 00:05'!
testAsComposed
	self assert: self description asContainer = self description.! !

!MAContainerTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:13'!
testAsContainer
	self assert: self description asContainer = self description.! !

!MAContainerTest methodsFor: 'testing-accessing' stamp: 'lr 3/24/2005 10:02'!
testChildren
	self assert: self description children isCollection.
	self assert: self description children isEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:07'!
testCollect
	| collected |
	self description add: self child1; add: self child2.
	collected := self description collect: [ :each | each ].
	
	self assert: self description ~= collected.
	self assert: self description size = collected size.
	self assert: self description children first = description children first.
	self assert: self description children second = description children second.! !

!MAContainerTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:26'!
testConcatenation
	| concatenate |
	concatenate := self description , self child1.
	self assert: concatenate size = 1.
	self assert: concatenate children first = self child1.
	
	concatenate := concatenate , self child2 asContainer.
	self assert: concatenate size = 2.
	self assert: concatenate children first = self child1.
	self assert: concatenate children second = self child2.! !

!MAContainerTest methodsFor: 'testing-copying' stamp: 'lr 3/24/2005 12:37'!
testCopy
	super testCopy.
	self description add: self child1; add: self child2.
	
	self deny: self description copy children == self description children.
	self assert: self description copy children first = self description children first.
	self assert: self description copy children second = self description children second.! !

!MAContainerTest methodsFor: 'testing-copying' stamp: 'lr 3/24/2005 12:10'!
testCopyFromTo
	| copied |
	self description add: self child1; add: self child2.
	copied := self description copyFrom: 1 to: 1.
	
	self assert: copied ~= self description.
	self assert: copied size = 1.
	self assert: copied children first = self description children first.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDetect
	self description add: self child1.
	self assert: (self description 
		detect: [ :each | self child1 = each ]) = self child1.
	self should: [ self description 
		detect: [ :each | self child2 = each ] ] raise: Error.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDetectIfNone
	self description add: self child1.
	self assert: (self description 
		detect: [ :each | self child1 = each ] 
		ifNone: [ 123 ]) = self child1.
	self assert: (self description 
		detect: [ :each | self child2 = each ] 
		ifNone: [ 123 ]) = 123.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:43'!
testDo
	| collection |
	collection := self description class defaultCollection.
	self description add: self child1; add: self child2.
	self description do: [ :each | collection add: each ].
	self assert: (self description children hasEqualElements: collection).! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDoSepratedBy
	| collection |
	collection := OrderedCollection new.
	self description add: self child1; add: self child2.
	self description 
		do: [ :each | collection add: each ]
		separatedBy: [ collection add: nil ].
	self assert: collection size = 3.
	self assert: collection first = self child1.
	self assert: collection second isNil.
	self assert: collection third = self child2.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:09'!
testEmpty
	self assert: self description isEmpty.
	self description add: self child1.
	self deny: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:08'!
testIncludes
	self deny: (self description includes: self child1).
	self description add: self child1.
	self assert: (self description includes: self child1).! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/27/2005 11:00'!
testInjectInto
	self description add: self child1; add: self child2.
	self assert: (self description 
		inject: 'start'
		into: [ :result :each | result , ' ' , each label ]) = 'start child1 child2'.! !

!MAContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:12'!
testMoveDown
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	
	self description moveDown: self child1.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	
	self description moveDown: self child1.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	! !

!MAContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:11'!
testMoveUp
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	
	self description moveUp: self child2.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	
	self description moveUp: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:09'!
testNotEmpty
	self deny: self description notEmpty.
	self description add: self child1.
	self assert: self description notEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:11'!
testReject
	| rejected |
	self description add: self child1; add: self child2.
	rejected := self description reject: [ :each | false ].
	
	self assert: self description ~= rejected.
	self assert: self description size = rejected size.
	self assert: self description children first = rejected children first.
	self assert: self description children second = rejected children second.! !

!MAContainerTest methodsFor: 'testing-removing' stamp: 'lr 3/24/2005 10:07'!
testRemove
	self description add: self child1; add: self child2.

	self description remove: self child1.
	self assert: self description size = 1.
	self deny: (self description includes: self child1).
	self assert: (self description includes: self child2).

	self description remove: self child2.
	self assert: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-removing' stamp: 'lr 3/24/2005 10:07'!
testRemoveAll
	self description add: self child1; add: self child2.

	self description removeAll.
	self assert: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:11'!
testSelect
	| selected |
	self description add: self child1; add: self child2.
	selected := self description select: [ :each | true ].
	
	self assert: self description ~= selected.
	self assert: self description size = selected size.
	self assert: self description children first = selected children first.
	self assert: self description children second = selected children second.! !

!MAContainerTest methodsFor: 'testing-accessing' stamp: 'lr 3/24/2005 10:03'!
testSize
	self assert: self description size isZero.
	self description add: self child1.
	self assert: self description size = 1.
	self description add: self child2.
	self assert: self description size = 2.! !

MAContainerTest subclass: #MAPriorityContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAPriorityContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 10:14'!
descriptionClass
	^MAPriorityContainer! !

!MAPriorityContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:15'!
testMoveDown
	" priority containers do sort automatically "! !

!MAPriorityContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:15'!
testMoveUp
	" priority containers do sort automatically "! !

MAContainerTest subclass: #MAReportContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAReportContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 10:14'!
descriptionClass
	^MAReportContainer! !

!MADescriptionTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:33'!
isAbstract
	^true! !

!MADescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:47'!
shouldInheritSelectors
	^true! !

!MADescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description
	^description! !

!MADescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description: anObject
	description := anObject! !

!MADescriptionTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:05'!
descriptionClass
	self subclassResponsibility! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:09'!
testComment
	description comment: 'bar'.
	self assert: description comment = 'bar'.! !

!MADescriptionTest methodsFor: 'testing-copying' stamp: 'lr 3/28/2005 19:29'!
testCopy
	| copy |
	copy := self description copy.
		
	self deny: self description = copy.
	self deny: self description properties == copy properties.
	
	self assert: self description properties = copy properties.
	self assert: self description properties size = copy properties size.
		
	self assert: self description label = copy label.
	self assert: self description comment = copy comment.
	self assert: self description priority = copy priority.
	
	self assert: self description persistent = copy persistent.
	self assert: self description readonly = copy readonly.
	self assert: self description required = copy required.
	self assert: self description visible = copy visible.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 3/27/2005 12:00'!
testHasComment
	self description comment: nil.
	self deny: self description hasComment.
	
	self description comment: ''.
	self deny: self description hasComment.
	
	self description comment: 'comment'.
	self assert:  self description hasComment.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 3/27/2005 12:00'!
testHasLabel
	self description label: nil.
	self deny: self description hasLabel.
	
	self description label: ''.
	self deny: self description hasLabel.
	
	self description label: 'label'.
	self assert:  self description hasLabel.! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:08'!
testLabel
	self description label: 'foo'.
	self assert: self description label = 'foo'.! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:09'!
testPriority
	description priority: 123.
	self assert: description priority = 123.! !

MADescriptionTest subclass: #MAElementTest
	instanceVariableNames: 'value wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAElementTest subclass: #MABinaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABinaryTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MABinaryDescription! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^ByteArray with: 1 with: 2 with: 3.! !

MAElementTest subclass: #MABooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABooleanTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MABooleanDescription! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^true! !

MAElementTest subclass: #MADateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADateTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MADateDescription! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Date newDay: 1 month: 2 year: 3456.! !

MAElementTest subclass: #MADurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADurationTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:03'!
descriptionClass
	^MADurationDescription! !

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:04'!
includedElement
	^Duration days: 1 hours: 2 minutes: 3 seconds: 4.! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
includedElement
	self subclassResponsibility! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
invalidElement
	^Object new! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
nullElement
	^nil! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
nullString
	^String new! !

!MAElementTest methodsFor: 'running' stamp: 'lr 3/30/2005 23:02'!
setUp
	super setUp.
	description := self descriptionClass selector: #value.
	wrapper := MAStraitWrapper on: self description model: self.! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/27/2005 10:50'!
testAcceessor
	self assert: self description accessor description = self description.
	self assert: self description accessor selector = #value.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:20'!
testAsContainer
	self assert: self description asContainer size = 1.
	self assert: (self description asContainer includes: self description).! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:35'!
testConcatenation
	| child1 child2 concatenate |
	child1 := self description copy.
	child2 := self description copy.
	
	concatenate := child1 , child2.
	self assert: concatenate size = 2.
	self assert: concatenate children first = child1.
	self assert: concatenate children second = child2.
	
	concatenate := child1 , concatenate.
	self assert: concatenate size = 3.
	self assert: concatenate children first = child1.
	self assert: concatenate children second = child1.
	self assert: concatenate children third = child2.! !

!MAElementTest methodsFor: 'testing-copying' stamp: 'lr 3/27/2005 12:08'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy accessor == self description accessor.
		self assert: copy default =  self description default.
		self assert: copy accessor description == copy ].! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:42'!
testDefault
	description default: #foo.
	self assert: description default = #foo.
	
	! !

!MAElementTest methodsFor: 'testing-testing' stamp: 'lr 3/14/2005 11:12'!
testIncludes
	self assert: (self description includes: self includedElement).
	self deny: (self description includes: self invalidElement).
	self deny: (self description includes: self nullElement).! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/23/2005 14:18'!
testKind
	self assert: (self includedElement isKindOf: self description kind).! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/27/2005 10:53'!
testMigrate
	| result |
	result := (MAStringDescription selector: #value)
		migrate: self includedElement
		from: self description.
	self assert: (self description 
		toString: self includedElement) = result.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/29/2005 21:01'!
testParseString
	self assert: (self description parseString: self nullElement) isNil.
	self assert: (self description parseString: self nullString) isNil.
	self assert: (self description includes: (description 
		parseString: (self description toString: self includedElement))).
	! !

!MAElementTest methodsFor: 'testing-settings' stamp: 'lr 3/19/2005 14:04'!
testPersistence
	self description bePersistent.
	self assert: self description persistent.
	self assert: self description isPersistent.
	
	self description beEphemeral.
	self deny: self description persistent.
	self deny: self description isPersistent.! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:24'!
testPriority
	self description priority: 123.
	self assert: self description priority = 123.! !

!MAElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:23'!
testPropertiesAt
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo) = 'bar'.
	self should: [ description propertyAt: #bar ] raise: Error.
	! !

!MAElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:24'!
testPropertiesAtIfAbsent
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (description propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'.
	! !

!MAElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:25'!
testPropertiesIncludes
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyIncludes: #foo).
	self deny: (description propertyIncludes: #bar).
	! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:00'!
testRead
	| other |
	self value: (other := self includedElement).
	self assert: self wrapper value = other.
	
	self value: (other := self nullElement).
	self assert: self wrapper value = other.! !

!MAElementTest methodsFor: 'testing-settings' stamp: 'lr 3/30/2005 23:07'!
testReadonly
	self description beReadonly.
	self assert: self description readonly.
	self assert: self description isReadonly.
	
	self description beWriteable.
	self deny: self description readonly.
	self deny: self description isReadonly.! !

!MAElementTest methodsFor: 'testing-settings' stamp: 'lr 3/30/2005 23:07'!
testRequired
	self description beRequired.
	self assert: self description required.
	self assert: self description isRequired.
	
	self description beOptional.
	self deny: self description required.
	self deny: self description isRequired.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/21/2005 20:14'!
testToString
	self assert: (self description toString: self includedElement) = self includedElement asLabel.
	self assert: (self description toString: self nullElement) = String new.! !

!MAElementTest methodsFor: 'testing-testing' stamp: 'lr 3/17/2005 23:07'!
testValidates
	self assert: (self description validates: self includedElement).
	self assert: (self description validates: self nullElement).
	self deny: (self description validates: self invalidElement).
	! !

!MAElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:51'!
testVisible
	self description beVisible.
	self assert: self description visible.
	self assert: self description isVisible.
	
	self description beHidden.
	self deny: self description visible.
	self deny: self description isVisible.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:00'!
testWrite
	| other |
	self wrapper value: (other := self includedElement).
	self assert: self value = other.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:04'!
testWriteIncluded
	self wrapper value: self invalidElement.
	self
		should: [ self wrapper commit  ]
		raise: MAValidationError.
		
	self wrapper value: self nullElement.
	self
		shouldnt: [ self wrapper commit ]
		raise: MAValidationError.
	
	self wrapper value: self includedElement.
	self
		shouldnt: [ self wrapper commit ]
		raise: MAValidationError.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:06'!
testWriteReadonly
	self description beReadonly.
	self
		should: [ self wrapper commit ]
		raise: MAReadonlyError.
		
	self description beWriteable.
	self
		shouldnt: [ self wrapper commit ]
		raise: MAReadonlyError.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:08'!
testWriteRequired
	self description beRequired.
	self value: self nullElement.
	self
		should: [ self wrapper commit ]
		raise: MARequiredError.
	self value: self includedElement.
	self
		shouldnt: [ self wrapper commit ]
		raise: MARequiredError.
		
	self description beOptional.
	self value: self nullElement.
	self
		shouldnt: [ self wrapper commit ]
		raise: MARequiredError.
	self value: self includedElement.
	self
		shouldnt: [ self wrapper commit ]
		raise: MARequiredError.! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/21/2005 20:03'!
value
	^value! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/21/2005 20:03'!
value: anObject
	value := anObject! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:59'!
wrapper
	^wrapper! !

MAElementTest subclass: #MANumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MANumberTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:12'!
descriptionClass
	^MANumberDescription! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^123! !

MAElementTest subclass: #MAOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAOptionsTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MAOptionsDescription! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^'Option 1'! !

!MAOptionsTest methodsFor: 'running' stamp: 'lr 3/29/2005 20:37'!
setUp
	super setUp.
	self description options 
		add: 'Option 1'; 
		add: 'Option 2'; 
		add: 'Option 3'.! !

!MAOptionsTest methodsFor: 'testing-copying' stamp: 'lr 3/29/2005 20:37'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy options == self description options.
		self assert: copy options = self description options ].! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:32'!
testNone
	self description none: 'none'.
	self assert: self description none = 'none'.! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:32'!
testOptions
	self description options: #( a b c ).
	self assert: self description options = #( a b c ).! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:35'!
testOptionsTextual
	self description options: #( 'a' 'b' ).
	self assert: self description optionsTextual = 'a
b'.

	self description optionsTextual: 'x
y'.
	self assert: self description options asArray = #( 'x' 'y' ).! !

MAElementTest subclass: #MAStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAStringTest subclass: #MAPasswordTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAPasswordTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAPasswordDescription! !

!MAStringTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAStringDescription! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^'Hello World'! !

MAStringTest subclass: #MASymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MASymbolDescription! !

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^#foo! !

MAStringTest subclass: #MATextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATextTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MATextDescription! !

MAElementTest subclass: #MATableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATableTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:47'!
descriptionClass
	^MATableDescription! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:51'!
includedElement
	^ #( 'a1' 'a2' 'b1' 'b2' 'c1' 'c2' )! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:56'!
invalidElement
	^ #( 'a' 'b' 'c' 'd' 'e' )! !

!MATableTest methodsFor: 'running' stamp: 'lr 3/29/2005 20:51'!
setUp
	super setUp.
	self description 
		columnLabels: #( a b );
		rowLabels: #( x y z ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 21:00'!
testCellCount
	self assert: self description cellCount = 6.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:54'!
testCellDescription
	| other |
	self description cellDescription: (other := MANumberDescription new).
	self assert: self description cellDescription = other.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:50'!
testColumnCount
	self assert: self description columnCount = 2.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:53'!
testColumnLabels
	self description columnLabels: #( '1' '2' ).
	self assert: self description columnLabels = #( '1' '2' ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:55'!
testColumnLabelsTextual
	self description columnLabels: #( '1' '2' ).
	self assert: self description columnLabelsTextual = '1
2'.

	self description columnLabelsTextual: '2
1'.
	self assert: self description columnLabels asArray = #( '2' '1' ).! !

!MATableTest methodsFor: 'testing-copying' stamp: 'lr 3/29/2005 20:52'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy rowLabels == self description rowLabels.
		self assert: copy rowLabels = self description rowLabels.
		self deny: copy columnLabels == self description columnLabels.
		self assert: copy columnLabels = self description columnLabels.
		self deny: copy cellDescription == self description cellDescription ].! !

!MATableTest methodsFor: 'testing-converting' stamp: 'lr 3/29/2005 21:02'!
testParseString
	" doesn't make much sense "! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:51'!
testRowCount
	self assert: self description rowCount = 3.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:53'!
testRowLabels
	self description rowLabels: #( '1' '2' ).
	self assert: self description rowLabels = #( '1' '2' ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:55'!
testRowLabelsTextual
	self description rowLabels: #( '1' '2' ).
	self assert: self description rowLabelsTextual = '1
2'.

	self description rowLabelsTextual: '2
1'.
	self assert: self description rowLabels asArray = #( '2' '1' ).! !

MAElementTest subclass: #MATimeStampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeStampTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeStampDescription! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:29'!
includedElement
	^TimeStamp year: 1 month: 2 day: 3456 hour: 7 minute: 8.! !

MAElementTest subclass: #MATimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeDescription! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Time hour: 1 minute: 2 second: 3.! !

TestCase subclass: #MADynamicObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/21/2005 20:10'!
testCalculated
	| object dummy |
	object := MADynamicObject on: [ Time millisecondClockValue ].
	dummy := object yourself.
	
	(Delay forMilliseconds: 2) wait.
	self assert: dummy < object.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testCollection
	| object |
	object := MADynamicObject on: [ OrderedCollection with: 1 with: 2 ].
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.
	
	object add: 3.
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testConstant
	| object |
	object := MADynamicObject on: [ self ].
	self assert: object = self.
	
	object := MADynamicObject on: [ 123 ].
	self assert: object = 123.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:36'!
testNil
	| object |
	object := MADynamicObject on: 'abc'.
	self deny: object isNil.
	self assert: object notNil.
	
	object := MADynamicObject on: nil.
	self assert: object isNil.
	self deny: object notNil.! !

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !
MAComparator initialize!
